-- CONFIG
APP_NAME = "Santera"  -- important, change it, it's name for config dir and files in appdata
APP_VERSION = 1341       -- client version for updater and login to identify outdated client
DEFAULT_LAYOUT = "retro" -- on android it's forced to "mobile", check code bellow

-- If you don't use updater or other service, set it to updater = ""
Services = {
  website = "http://otclient.ovh", -- currently not used
  updater = "https://update.santera.pl/api/updater.php",
  stats = "",
  crash = "http://otclient.ovh/api/crash.php",
  feedback = "http://otclient.ovh/api/feedback.php",
  status = "santera.pl/api/status.php"
}

-- Servers accept http login url, websocket login url or ip:port:version
Servers = {
myserver = "127.0.0.1:7171:860",
--myserver = "5.196.154.113:7173:860",
-- serverName ="ipAddress:port:version"
}


math.randomseed(os.time())

local proxyId = math.random(1,9)
local vpsPort = tonumber(6550 + proxyId)

g_proxy.addProxy("p1.santera.pl", vpsPort, 0)
g_proxy.addProxy("p2.santera.pl", vpsPort, 0)
g_proxy.addProxy("p3.santera.pl", vpsPort, 0)
g_proxy.addProxy("p4.santera.pl", vpsPort, 0)
g_proxy.addProxy("p5.santera.pl", vpsPort, 0)
g_proxy.addProxy("p6.santera.pl", vpsPort, 0)
g_proxy.addProxy("p7.santera.pl", vpsPort, 0)
g_proxy.addProxy("p8.santera.pl", vpsPort, 0)
g_proxy.addProxy("p9.santera.pl", vpsPort, 0)
g_proxy.addProxy("p10.santera.pl", vpsPort, 0)
g_proxy.addProxy("p11.santera.pl", vpsPort, 0)
g_proxy.addProxy("p12.santera.pl", vpsPort, 0)

--Server = "ws://otclient.ovh:3000/"
--Server = "ws://127.0.0.1:88/"
--USE_NEW_ENERGAME = true -- uses entergamev2 based on websockets instead of entergame
ALLOW_CUSTOM_SERVERS = false -- if true it shows option ANOTHER on server list

g_app.setName("Santera")
-- CONFIG END

-- print first terminal message
g_logger.info(os.date("== application started at %b %d %Y %X"))
g_logger.info(g_app.getName() .. ' ' .. g_app.getVersion() .. ' rev ' .. g_app.getBuildRevision() .. ' (' .. g_app.getBuildCommit() .. ') made by ' .. g_app.getAuthor() .. ' built on ' .. g_app.getBuildDate() .. ' for arch ' .. g_app.getBuildArch())

if not g_resources.directoryExists("/data") then
  g_logger.fatal("Data dir doesn't exist.")
end

if not g_resources.directoryExists("/modules") then
  g_logger.fatal("Modules dir doesn't exist.")
end

-- settings
g_configs.loadSettings("/config.otml")

-- set layout
local settings = g_configs.getSettings()
local layout = DEFAULT_LAYOUT
if g_app.isMobile() then
  layout = "mobile"
elseif settings:exists('layout') then
  layout = settings:getValue('layout')
end
g_resources.setLayout(layout)

-- load mods
g_modules.discoverModules()
g_modules.ensureModuleLoaded("corelib")
  
local function loadModules()
  -- libraries modules 0-99
  g_modules.autoLoadModules(99)
  g_modules.ensureModuleLoaded("gamelib")

  -- client modules 100-499
  g_modules.autoLoadModules(499)
  g_modules.ensureModuleLoaded("client")

  -- game modules 500-999
  g_modules.autoLoadModules(999)
  g_modules.ensureModuleLoaded("game_interface")

  -- mods 1000-9999
  g_modules.autoLoadModules(9999)
end

-- report crash
if type(Services.crash) == 'string' and Services.crash:len() > 4 and g_modules.getModule("crash_reporter") then
  g_modules.ensureModuleLoaded("crash_reporter")
end

-- run updater, must use data.zip
if type(Services.updater) == 'string' and Services.updater:len() > 4 
  and g_resources.isLoadedFromArchive() and g_modules.getModule("updater") then
  g_modules.ensureModuleLoaded("updater")
  return Updater.init(loadModules)
end
loadModules()
