  ---- HOLD TARGET
 
local targetID = nil

-- escape when attacking will reset hold target
onKeyPress(function(keys)
    if keys == "Escape" and targetID then
        targetID = nil
    end
end)

addIcon("Hold Target", {item={id=796 , count=1}, text="RE-ATTACK"}, macro(100, function(m)
    -- if attacking then save it as target, but check pos z in case of marking by mistake on other floor
    if target() and target():getPosition().z == posz() and not target():isNpc() then
        targetID = target():getId()
    elseif not target() then
        -- there is no saved data, do nothing
        if not targetID then return end

        -- look for target
        for i, spec in ipairs(getSpectators()) do
            local sameFloor = spec:getPosition().z == posz()
            local oldTarget = spec:getId() == targetID
            
            if sameFloor and oldTarget then
                attack(spec)
            end
        end
    end
end))

-- FASTER heal
setDefaultTab("Tools")
macro(50, "Heal Spell",  function()
  if (hppercent() <= tonumber(storage.belowhp)) then
    say(storage.healspell) 
  end
end)
addLabel("", "Heal Spell:")

addTextEdit("", storage.healspell or "exura vita", function(widget, text)
  storage.healspell = text
end)

addLabel("", "Heal Below % Hp:")

addTextEdit("", storage.belowhp or "99", function(widget, text)
  storage.belowhp = text
end)
UI.Separator()

---- SPELL / TARGET / ZASIEG

function countMonstersInRange(range)
      local monsters = 0
      for _, spec in pairs(getSpectators(false)) do
        if spec:isMonster() and distanceFromPlayer(spec:getPosition()) <= range then
          monsters = monsters + 1
        end
      end
      return monsters
  end

  addIcon("Spells", {item=23541, switchable=true, text="UE/TARGET"}, 
  macro(200, function()
      local range = tonumber(storage.Range) or 6
      local numMonsters = countMonstersInRange(range)

      if numMonsters > 1 then
        say(storage.Spell2)
      elseif numMonsters == 1 then
        say(storage.Spell1)
      end
  end))

  UI.Label("TARGET SPELL")
  addTextEdit("Spell1", storage.Spell1 or "Single target", function(widget, text)
      storage.Spell1 = text 
  end)
    UI.Label("UE SPELL")
  addTextEdit("Spell2", storage.Spell2 or "Multi target", function(widget, text)
      storage.Spell2 = text 
  end)
  UI.Label("RANGE SQM")
  addTextEdit("Range", storage.Range or "6", function(widget, text)
      storage.Range = tonumber(text) or 6 
  end)
  UI.Separator()

----UTAMKA

local lastCast = 0
addIcon("UTAMA", {item=9392, switchable=true, text="UTAMA"},
macro(250, function()
  if not hasManaShield() or (now - lastCast) > 90000 then
    say("Utamo Vita")
    lastCast = now
  end
end))

---- POT MR

local manaId = tonumber(storage.manauh)
local BELOW_MANA = 95

UI.Label("MR ID")

UI.TextEdit(storage.manauh or "3185", function(widget, text)
  storage.manauh = text
end)

addIcon("POT GMP", {item=238, switchable=true, text="MR"},
macro(100, function()
  if manapercent() <= BELOW_MANA then
    usewith(manaId, player) 
  end
end))
UI.Separator()

----TARGETOWKA

local lastSpellTime = 0

-- Definicja funkcji do dodawania ikony
addIcon("TARGETOWKA", {item=946, switchable=true, text="TARGET SPELL"},
  macro(100,  function() 
     -- Sprawdź, czy gracz znajduje się w Protection Zone (PZ)
     if isInPz() then return end
     -- Sprawdź, czy gracz zaznaczył cel
     local target = getTarget()
     if not target then return end
     -- Sprawdź, czy od ostatniego użycia minęło wystarczająco dużo czasu
     if os.time() - lastSpellTime < 1 then return end -- Tutaj można dostosować czas, jeśli potrzeba
     -- Uzyskaj nazwę czaru z pola tekstowego
     local spell = storage.TARGETOWKAspell or "arrow strike"
     -- Użyj komendy 'say' do wykonania czaru
     say(spell)
     -- Zaktualizuj czas ostatniego użycia czaru
     lastSpellTime = os.time()
  end))

-- Dodaj etykietę UI (interfejsu użytkownika) dla pola tekstowego
UI.Label("ONLY TARGET SPELL")

-- Dodaj pole tekstowe, w którym można wprowadzać nazwę czaru
addTextEdit("TARGET SPELL", storage.TARGETOWKAspell or "arrow strike", function(widget, text)
  -- Zapisz wprowadzoną nazwę czaru w pamięci
  storage.TARGETOWKAspell = text
end)

UI.Separator()

---- AOL

addIcon("Aol", {item=9303, switchable=true, text="AOL"},
macro(100, "Aol", function()
  if not getNeck() then
      say('!aol')
  end
end))

---- STOP CAVEBOT I TARGEBOT 

addIcon("StopCTIcon", {item={id=10476, count=1}, text="STOP C&T"}, macro(200, function(m) 
    CaveBot.setOn()
    TargetBot.setOn()
    schedule(200, function() 
        if m.isOff() then
            CaveBot.setOff()
            TargetBot.setOff()
        end
    end)
end))

---- EXP GAIN / H

UI.Separator()

local title = UI.Label("Exp Gain")
title:setColor("orange")
UI.Separator()

local expgain = 0
local startTime = os.time()  -- Start time
local expLabel = UI.DualLabel("Exp:", "0", contentsPanel).right
local expPerHourLabel = UI.DualLabel("XP/h:", "0", contentsPanel).right

local m = macro(5000, "Start", function() end)

UI.Button("Reset", function()
    expgain = 0
    startTime = os.time()  -- Reset start time
    expLabel:setText(format_thousand(expgain))
    expPerHourLabel:setText("0")
end)


function format_thousand(num)
    local numStr = tostring(num)
    local formatted = ""
    local count = 0

    for i = #numStr, 1, -1 do
        count = count + 1
        formatted = numStr:sub(i, i) .. formatted
        if count % 3 == 0 and i ~= 1 then
            formatted = "," .. formatted
        end
    end

    return formatted
end

local function updateExpPerHour()
    local elapsedTime = os.time() - startTime
    local hoursElapsed = elapsedTime / 3600  -- convert seconds to hours
    local xpPerHour = expgain / hoursElapsed
    expPerHourLabel:setText(format_thousand(math.floor(xpPerHour)))
end

onTextMessage(function(mode, text)
    if m.isOff() then return end
    if mode ~= 28 then return end
    if string.match(text, "experience points.") then
        local regex = 'You gained ([0-9]*) experience points.'
        local data = regexMatch(text, regex)[1]
        if data then
            local m_xp = tonumber(data[2]:trim(g))  -- convert to number
            if m_xp then
                expgain = expgain + m_xp
                expLabel:setText(format_thousand(expgain))
                updateExpPerHour()  -- Update XP/h label
            end
        end
    end
end)

----BUG MAPA

local function checkPos(x, y)
 xyz = g_game.getLocalPlayer():getPosition()
 xyz.x = xyz.x + x
 xyz.y = xyz.y + y
 tile = g_map.getTile(xyz)
 if tile then
  return g_game.use(tile:getTopUseThing())  
 else
  return false
 end
end


bugMap = macro(1, function() 
 if modules.corelib.g_keyboard.isKeyPressed('Up') then
  checkPos(0, -5)
 elseif modules.corelib.g_keyboard.isKeyPressed('Right') then
  checkPos(5, 0)
 elseif modules.corelib.g_keyboard.isKeyPressed('Down') then
  checkPos(0, 5)
 elseif modules.corelib.g_keyboard.isKeyPressed('Left') then
  checkPos(-5, 0)
 end
end)

bugMapIcon = addIcon("Bug Map", {item=3555, text="DASH"}, function(icon, isOn)
  modules.game_console.consoleTextEdit:setVisible(not isOn)
  bugMap.setOn(isOn)
end)
